//+------------------------------------------------------------------+
//|                                                     Chimp1_2.mq4 |                                     
//+------------------------------------------------------------------+
//Revision history; 

//
#property indicator_separate_window
#property indicator_buffers   3
#property indicator_color1    White
#property indicator_width1    2
#property indicator_color2    Lime
#property indicator_color3    Red

//---- input parameters
extern int     TimeFrame=0;
extern double  Weight=5;
//---- buffers
double MA[];
double UP[];
double DN[];
double PDM[];//Not displayed
double MDM[];//Not displayed

string indName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   TimeFrame = MathMax(TimeFrame,Period());
   indName = WindowExpertName();
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MA);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,UP);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,DN);
   SetIndexBuffer(3,PDM); 
   SetIndexBuffer(4,MDM);   
   
   //---- name for DataWindow and indicator subwindow label
   string short_name="Chimp1_2";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Chimp1_2");
   SetIndexLabel(1,"Chimp1_2");
   SetIndexLabel(2,"Chimp1_2");
   //----
   SetIndexDrawBegin(0,4);
   SetIndexDrawBegin(1,4);
   SetIndexDrawBegin(2,4);
   SetLevelStyle(STYLE_DOT,1,White);  
   SetLevelValue(0,0.6);
   SetLevelValue(1,0.3);
   SetLevelValue(2,-0.3);
   SetLevelValue(3,-0.6);  
    
//--------- Safety overrides on user settings
   if (Weight<1.0)Weight=1.0;

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (TimeFrame!=Period())
         {
            limit = MathMin(MathMax(limit,3*TimeFrame/Period()),Bars-1);
            for(int i= limit; i>=0; i--) //Main loop begins after history bars filled.
            {
                int y = iBarShift(NULL,TimeFrame,Time[i]);
                MA[i] = iCustom(NULL,TimeFrame,indName,0,Weight,0,y);
                UP[i] = iCustom(NULL,TimeFrame,indName,0,Weight,1,y);
                DN[i] = iCustom(NULL,TimeFrame,indName,0,Weight,2,y);

            }
            return(0);
         }

   for( i= limit; i>=0; i--) //Main loop begins after history bars filled.
   {     
   y=i;
   PDM[i]=0;
   MDM[i]=0;
   if(iClose(NULL,TimeFrame,y)>iClose(NULL,TimeFrame,y+1))PDM[i]=iClose(NULL,TimeFrame,y)-iClose(NULL,TimeFrame,y+1);//This array is not displayed.
   else MDM[i]=iClose(NULL,TimeFrame,y+1)-iClose(NULL,TimeFrame,y);//This array is not displayed.

   PDM[i]=((Weight-1)*PDM[i+1] + PDM[i])/Weight;//ema.
   MDM[i]=((Weight-1)*MDM[i+1] + MDM[i])/Weight;//ema.

   double TR=PDM[i]+MDM[i];
   if(TR>0){double pdi=PDM[i]/TR; double mdi=MDM[i]/TR;}
   else{pdi=0;mdi=0;}
   double di_diff=pdi-mdi;
   if(di_diff<0)di_diff= -di_diff;
   double di_sum=pdi+mdi;
   double di_factor=0;
   if(di_sum>0)MA[i]=di_diff/di_sum;
   else MA[i]=0;
   if(MDM[i]>PDM[i])MA[i]= -MA[i];//Outputs main signal line.
   UP[i]=0;
   DN[i]=0;
   if(MA[i]>0)UP[i]=MA[i];//Bulls histogram
   if(MA[i]<0)DN[i]=MA[i];//Bears histogram
    
   
   }
  
//----
   return(0);
  }
//+------------------------------------------------------------------+

